<template>
  <el-dialog :append-to-body="true" :close-on-click-modal="false" width="1000px" title="选择优惠券" :visible.sync="visible">
    <div class="proSelectBox">
      <!-- 搜索 -->
      <div class="topSearch">
        <div class="formSearch">
          <el-form :inline="true" :model="formData">
            <el-form-item label="">
              <el-input v-model="formData.keyword" maxlength="20" class="inputKeyword" placeholder="请输入优惠券名称" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" plain @click="search">查询</el-button>
              <el-button plain @click="clear">重置</el-button>
            </el-form-item>
          </el-form>
        </div>
      </div>
      <!-- 表格 -->
      <div class="tableBox">
        <el-table
          ref="multipleTable" :data="tableData" max-height="500" border
          row-key="productId" style="width: 100%"
          @selection-change="handleSelectionChange"
        >
          <el-table-column v-if="isMultiple" width="40" type="selection" :reserve-selection="true" fixed="left" />
          <el-table-column v-else label="" width="40" align="center">
            <template slot-scope="scope">
              <el-radio v-model="tableRadio" :label="scope.row"><i /></el-radio>
            </template>
          </el-table-column>
          <el-table-column prop="activityName" label="优惠券名称" width="180">
          </el-table-column>
          <el-table-column prop="content" label="内容">
          </el-table-column>
          <el-table-column prop="activityStartTime" label="活动开始时间">
          </el-table-column>
          <el-table-column prop="activityEndTime" label="活动结束时间">
          </el-table-column>
        </el-table>
        <div class="fenye">
          <el-pagination
            :current-page="currentPage" :hide-on-single-page="true" :page-sizes="[10, 20, 50, 100]"
            :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="total"
            @size-change="handleSizeChange" @current-change="handleCurrentChange"
          />
        </div>
      </div>
    </div>
    <span slot="footer" class="dialog-footer">
      <el-button @click="visible = false">取 消</el-button>
      <el-button type="primary" @click="doSubmit">确 定</el-button>
    </span>
  </el-dialog>
</template>

<script>
import {
  getCoupons
} from '@/api/public'
export default {
  name: 'CouponTable',
  props: {
    cId: {
      type: Number,
      default: 0
    },
    cIds: {
      type: Array,
      default: () => []
    },
    isMultiple: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      visible: false,
      tableRadio: '',
      formData: {
        keyword: ''
      },
      currentPage: 1,
      total: 0,
      pageSize: 10,
      tableData: [],
      multipleSelection: []
    }
  },
  mounted() {
    this.getTableData()
  },
  methods: {
    // 获取优惠券信息
    getTableData() {
      var _this = this
      const params = {
        page: this.currentPage,
        pageSize: this.pageSize
      }
      if (this.formData.keyword) {
        params.search = this.formData.keyword
      }
      getCoupons(params).then((res) => {
        _this.tableData = res.data.list
        _this.total = res.data.total
        // 表格斌值
        if (this.isMultiple) {
          if (this.cIds.length > 0) {
            this.tableData.forEach((row) => {
              for (let i = 0; i < this.cIds.length; i++) {
                if (this.cIds[i] === row.activityId) {
                  this.$refs.multipleTable.toggleRowSelection(row, true)
                }
              }
            })
          }
        } else if (this.cId !== 0) {
          this.tableRadio = this.cId
          this.tableData.forEach((row) => {
            if (this.cId === row.activityId) {
              this.tableRadio = row
            }
          })
        }
      })
    },
    // 搜索
    search() {
      this.getTableData()
    },
    clear() {
      this.formData.keyword = ''
      this.getTableData()
    },
    // 每页条数改变
    handleSizeChange(val) {
      this.pageSize = val
      this.getTableData()
    },
    // 当前页改变
    handleCurrentChange(val) {
      this.currentPage = val
      this.getTableData()
    },
    // 多选改变
    handleSelectionChange(val) {
      this.multipleSelection = val
    },
    // 提交
    doSubmit() {
      if (this.isMultiple) {
        this.$emit('doSubmit', this.multipleSelection)
      } else {
        this.$emit('doSubmit', this.tableRadio)
      }
      this.visible = false
    }
  }
}
</script>

<style scoped>
.proSelectBox .formSearch .inputKeyword {
	width: 200px;
}
</style>
